<?php
ob_start();
header('Content-Type: text/html; charset=utf-8');
include_once("access.php");
include_once("asipto/libs/cmds/serxr.php");

checkAccess();

global $g_BizSystem;
?>

<html>
<head>
  <title>SIREMIS - Kamailio (OpenSER) Web Admin Interface</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <link rel="stylesheet" href="../css/openbiz.css" type="text/css">
  <script type="text/javascript" src="../js/clientUtil.js"></script>
  <script type="text/javascript" src="../js/orichtext.js"></script>
</head>
<body>

<?php
	$tabformobj = $g_BizSystem->GetObjectFactory()->GetObject("main.CmdMainView");
	$tabformobj->GetChildForm("menuCmdTabs")->SetCurrentTab("xrcmds");
	$sHTML = $tabformobj->Render();
	echo $sHTML;
	
	$xrobj = $g_BizSystem->GetService("siremisXRCommands");
?>
<br />
<div align="center">
<?php
	if($xrobj)
	{
		echo "<strong>XMLRPC Command Panel</strong><br /><br />\n";
?>
		<FORM action="xrcmds.php" method="post">
			<INPUT type="text" name="cmd" size="40"/>
			<INPUT type="submit" name="submit" value="Run"/>
			<INPUT type="reset"/>
		</FORM>
		<br />
<?php
		$xrcmds = $xrobj->GetXRConfig()->GetXRCommands();
		if($xrcmds)
		{
?>
		<br />
		<br />
		<FORM action="xrcmds.php" method="post">
			<SELECT name="cmdid">
<?php
			foreach ($xrcmds as $xrcobj) {
?>
			<OPTION value="<?php echo $xrcobj->GetName(); ?>"><?php echo $xrcobj->GetTitle();?></OPTION>
<?php
			}
?>
			</SELECT>
			<INPUT type="submit" name="submit" value="Run"/>
		</FORM>
		<br />
<?php
		}
		$vcmd = $_POST["cmd"];
		if(!$vcmd || $vcmd=="")
		{
			$vcmdid = $_POST["cmdid"];
			if($vcmdid && $vcmdid!="")
			{
				$vcmd = $xrobj->GetXRConfig()->GetXRCommand($vcmdid)->GetCommand();
			}
		}
		if($vcmd && $vcmd!="")
		{
			$xre = new serxr(
						$xrobj->GetXRConfig()->GetRSocket()->GetPath(),
						$xrobj->GetXRConfig()->GetRSocket()->GetAddress(),
						$xrobj->GetXRConfig()->GetRSocket()->GetPort(),
						$xrobj->GetXRConfig()->GetRSocket()->GetTimeout()
					);
			if ($xre->ready != true) {
				$xre->sxr_close();
				die(printf("Unable to create XMLRPC client\r\n"));
			}
			$xrret = $xre->sxr_command($vcmd);

?>
				<hr size="1px" width="50%"/>
				<br />
				<span style="color: #AA8800;">Result For XMLRPC Command: [ <?php echo $vcmd; ?> ]</span>
				<br />
				<br />
<?php
			if($xrret)
			{
				if($xrobj->GetXRConfig()->getMode()=="rich")
				{
?>
<script language="JavaScript" type="text/javascript">
<!--
//build richTextEditor
initRTE("../images/orte/", "../", "", false);
document.writeln('<br><br>');
var rte = new richTextEditor('rte');
<?php
	$content = $xre->toRichStr();
?>
rte.html = '<?=$content;?>';
rte.width = 600;
rte.height = 400;
// rte.readOnly = true;
rte.toolbar1 = false;
rte.toolbar2 = false;
rte.toggleSrc = false;
rte.build();
//-->
</script>
<?php
				} else {
?>
<TEXTAREA name="mitext" rows="20" cols="80" readonly>
<?php $xre->printText(); ?>
</TEXTAREA>
<?php
				}
			} else {
				echo "NO RESULT";
			}
			$xre->sxr_close();
		}
	} else {
		echo "XMLRPC Commands Service not configured\n";
	}
?>
</div>
<p align="center">&nbsp;</p>
<p align="center"><font face="Arial"><i>Powered by <a href="http://www.asipto.com" target="_blank">Asipto SRL</a> - &copy; 2009 Asipto SRL</i></font></p>
</body>
</html>
